cdrom: change pause timing again
[pcsx_rearmed.git] / configure
... / ...
CommitLineData
1#!/bin/sh
2# some elements originated from qemu configure
3set -e
4
5TMPC="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}.c"
6TMPO="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}.o"
7TMPB="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}"
8trap "rm -f $TMPC $TMPO $TMPB" EXIT INT QUIT TERM
9rm -f config.log
10
11compile_object()
12{
13 c="$CC $CFLAGS -c $TMPC -o $TMPO $@"
14 echo $c >> config.log
15 $c >> config.log 2>&1
16}
17
18compile_binary()
19{
20 c="$CC $CFLAGS $TMPC -o $TMPB $LDFLAGS $MAIN_LDLIBS $@"
21 echo $c >> config.log
22 $c >> config.log 2>&1
23}
24
25check_define()
26{
27 $CC -E -dD $CFLAGS include/arm_features.h | grep -q "$1" || return 1
28 return 0
29}
30
31check_define_val()
32{
33 $CC -E -dD $CFLAGS include/arm_features.h | grep "$1" | awk '{print $3}'
34 return 0
35}
36
37# setting options to "yes" or "no" will make that choice default,
38# "" means "autodetect".
39
40platform_list="generic pandora maemo caanoo libretro"
41platform="generic"
42builtin_gpu_list="neon peops unai unai_old"
43builtin_gpu=""
44sound_driver_list="oss alsa pulseaudio sdl libretro"
45sound_drivers=""
46plugins="plugins/spunull/spunull.so \
47plugins/dfxvideo/gpu_peops.so plugins/gpu_unai_old/gpu_unai_old.so plugins/gpu_unai/gpu_unai.so"
48drc_cache_base="no"
49have_armv5=""
50have_armv6=""
51have_armv7=""
52have_arm_neon=""
53have_arm_neon_asm=""
54have_tslib=""
55have_gles=""
56have_c64x_dsp=""
57enable_dynarec="yes"
58need_sdl="no"
59need_xlib="no"
60need_libpicofe="yes"
61need_warm="no"
62CFLAGS_GLES=""
63LDLIBS_GLES=""
64# these are for known platforms
65optimize_cortexa8="no"
66optimize_arm926ej="no"
67
68# hardcoded stuff
69if [ "${OSTYPE}" = "FreeBSD" ]; then
70 CC="clang"
71 CXX="clang++"
72 CFLAGS="-I/usr/local/include -L/usr/local/lib"
73 MAKE=gmake
74else
75 CC="${CC-${CROSS_COMPILE}gcc}"
76 CXX="${CXX-${CROSS_COMPILE}g++}"
77fi
78AS="${AS-${CROSS_COMPILE}as}"
79AR="${AS-${CROSS_COMPILE}ar}"
80MAIN_LDLIBS="$LDLIBS -ldl -lm -lpthread"
81config_mak="config.mak"
82
83if [ "${OSTYPE}" = "FreeBSD" ]; then
84 SYSROOT="$sysroot"
85 [ "x${SDL_CONFIG}" = "x" ] && SDL_CONFIG="${SYSROOT}/usr/local/bin/sdl-config"
86else
87 SYSROOT="$(${CC} --print-sysroot)"
88 [ "x${SDL_CONFIG}" = "x" ] && SDL_CONFIG="${SYSROOT}/usr/bin/sdl-config"
89fi
90
91fail()
92{
93 echo "$@"
94 if test -n "$DUMP_CONFIG_LOG"; then cat config.log; fi
95 exit 1
96}
97
98# call during arg parsing, so that cmd line can override platform defaults
99set_platform()
100{
101 platform=$1
102 case "$platform" in
103 generic)
104 ;;
105 pandora)
106 sound_drivers="oss alsa"
107 drc_cache_base="yes"
108 optimize_cortexa8="yes"
109 have_arm_neon="yes"
110 need_xlib="yes"
111 ;;
112 maemo)
113 drc_cache_base="yes"
114 optimize_cortexa8="yes"
115 have_arm_neon="yes"
116 ;;
117 caanoo)
118 sound_drivers="oss"
119 drc_cache_base="yes"
120 optimize_arm926ej="yes"
121 need_warm="yes"
122 ;;
123 libretro)
124 sound_drivers="libretro"
125 need_libpicofe="no"
126 ;;
127 *)
128 fail "unsupported platform: $platform"
129 ;;
130 esac
131}
132
133for opt do
134 optarg=`expr "x$opt" : 'x[^=]*=\(.*\)'` || true
135 case "$opt" in
136 --help|-h) show_help="yes"
137 ;;
138 --platform=*) set_platform "$optarg"
139 ;;
140 --gpu=*) builtin_gpu="$optarg"
141 ;;
142 --sound-drivers=*) sound_drivers="$optarg"
143 ;;
144 --enable-neon) have_arm_neon="yes"
145 ;;
146 --disable-neon) have_arm_neon="no"
147 ;;
148 --disable-dynarec) enable_dynarec="no"
149 ;;
150 *) echo "ERROR: unknown option $opt"; show_help="yes"
151 ;;
152 esac
153done
154
155if [ "$show_help" = "yes" ]; then
156 echo "options:"
157 echo " --help print this message"
158 echo " --platform=NAME target platform [$platform]"
159 echo " available: $platform_list"
160 echo " --gpu=NAME builtin gpu plugin [guessed]"
161 echo " available: $builtin_gpu_list"
162 echo " --sound-drivers=LIST sound output drivers [guessed]"
163 echo " available: $sound_driver_list"
164 echo " --enable-neon"
165 echo " --disable-neon enable/disable ARM NEON optimizations [guessed]"
166 echo " --disable-dynarec disable dynamic recompiler"
167 echo " (dynarec is only available and enabled on ARM)"
168 echo "influential environment variables:"
169 echo " CROSS_COMPILE CC CXX AS AR CFLAGS ASFLAGS LDFLAGS LDLIBS"
170 exit 1
171fi
172
173# validate selections
174if [ "x$builtin_gpu" != "x" ]; then
175 if ! echo $builtin_gpu_list | grep -q "\<$builtin_gpu\>"; then
176 fail "unsupported builtin gpu plugin: $builtin_gpu"
177 fi
178fi
179
180if [ "x$sound_drivers" != "x" ]; then
181 for d in $sound_drivers; do
182 if ! echo $sound_driver_list | grep -q "\<$d\>"; then
183 fail "unsupported sound driver: $sound_driver"
184 fi
185 done
186fi
187
188if [ "$need_libpicofe" = "yes" ]; then
189 if ! test -f "frontend/libpicofe/README"; then
190 fail "libpicofe is missing, please run 'git submodule init && git submodule update'"
191 fi
192fi
193
194if [ "$need_warm" = "yes" ]; then
195 if ! test -f "frontend/warm/README"; then
196 fail "wARM is missing, please run 'git submodule init && git submodule update'"
197 fi
198fi
199
200# basic compiler test
201cat > $TMPC <<EOF
202#include <zlib.h>
203int main(void) { return 0; }
204EOF
205if ! compile_binary; then
206 fail "compiler test failed, please check config.log"
207fi
208
209if [ -z "$ARCH" ]; then
210 ARCH=`$CC -dumpmachine | awk -F '-' '{print $1}'`
211fi
212
213case "$ARCH" in
214arm*)
215 # ARM stuff
216 ARCH="arm"
217
218 if [ "$optimize_cortexa8" = "yes" ]; then
219 CFLAGS="$CFLAGS -mcpu=cortex-a8 -mtune=cortex-a8"
220 ASFLAGS="$ASFLAGS -mcpu=cortex-a8"
221 fi
222 if [ "$optimize_arm926ej" = "yes" ]; then
223 CFLAGS="$CFLAGS -mcpu=arm926ej-s -mtune=arm926ej-s"
224 ASFLAGS="$ASFLAGS -mcpu=arm926ej-s -mfloat-abi=softfp"
225 fi
226
227 if [ "x$have_arm_neon" = "x" ]; then
228 # detect NEON from user-supplied cflags to enable neon code
229 have_arm_neon=`check_define __ARM_NEON__ && echo yes` || true
230 fi
231 if [ "x$have_armv7" = "x" ]; then
232 if check_define HAVE_ARMV7; then
233 have_armv7="yes"
234 have_armv6="yes"
235 have_armv5="yes"
236 fi
237 fi
238 if [ "x$have_armv6" = "x" ]; then
239 if check_define HAVE_ARMV6; then
240 have_armv6="yes"
241 have_armv5="yes"
242 fi
243 fi
244 if [ "x$have_armv5" = "x" ]; then
245 have_armv5=`check_define HAVE_ARMV5 && echo yes` || true
246 fi
247
248 if [ "x$builtin_gpu" = "x" ]; then
249 if [ "$have_arm_neon" = "yes" ]; then
250 builtin_gpu="neon"
251 elif [ "$have_armv7" != "yes" ]; then
252 # pre-ARMv7 hardware is usually not fast enough for peops
253 builtin_gpu="unai_old"
254 else
255 builtin_gpu="peops"
256 fi
257 fi
258
259 # automatically set mfpu and mfloat-abi if they are not set
260 if [ "$have_arm_neon" = "yes" ]; then
261 fpu="neon"
262 elif [ "$have_armv6" = "yes" ]; then
263 fpu="vfp"
264 fi
265 if [ "x$fpu" != "x" ]; then
266 echo "$CFLAGS" | grep -q -- '-mfpu=' || CFLAGS="$CFLAGS -mfpu=$fpu"
267 echo "$ASFLAGS" | grep -q -- '-mfpu=' || ASFLAGS="$ASFLAGS -mfpu=$fpu"
268 floatabi_set_by_gcc=`$CC -v 2>&1 | grep -q -- --with-float= && echo yes` || true
269 if [ "$floatabi_set_by_gcc" != "yes" ]; then
270 echo "$CFLAGS" | grep -q -- '-mfloat-abi=' || CFLAGS="$CFLAGS -mfloat-abi=softfp"
271 echo "$ASFLAGS" | grep -q -- '-mfloat-abi=' || ASFLAGS="$ASFLAGS -mfloat-abi=softfp"
272 fi
273 fi
274
275 # must disable thumb as recompiler can't handle it
276 if check_define __thumb__; then
277 CFLAGS="$CFLAGS -marm"
278 fi
279
280 # warn about common mistakes
281 if [ "$have_armv5" != "yes" ]; then
282 if ! echo "$CFLAGS" | grep -q -- '-mcpu=\|-march='; then
283 echo "Warning: compiling for ARMv4, is that really what you want?"
284 echo "You probably should specify -mcpu= or -march= like this:"
285 echo " CFLAGS=-march=armv6 ./configure ..."
286 fi
287 fi
288 if [ "$have_arm_neon" = "yes" -a "$have_armv7" != "yes" ]; then
289 echo "Warning: compiling for NEON, but not ARMv7?"
290 echo "You probably want to specify -mcpu= or -march= like this:"
291 echo " CFLAGS=-march=armv7-a ./configure ..."
292 fi
293 have_arm_neon_asm=$have_arm_neon
294 ;;
295aarch64)
296 have_arm_neon="yes"
297 have_arm_neon_asm="no"
298 if [ "x$builtin_gpu" = "x" ]; then
299 builtin_gpu="neon"
300 fi
301 ;;
302x86_64)
303 enable_dynarec="no"
304 if [ "x$builtin_gpu" = "x" ]; then
305 builtin_gpu="neon"
306 fi
307 ;;
308*)
309 # dynarec only available on ARM
310 enable_dynarec="no"
311 ;;
312esac
313
314if [ "x$builtin_gpu" = "x" ]; then
315 builtin_gpu="peops"
316fi
317
318# supposedly we can avoid -fPIC on armv5 for slightly better performace?
319if [ "$ARCH" != "arm" -o "$have_armv6" = "yes" ]; then
320 PLUGIN_CFLAGS="$PLUGIN_CFLAGS -fPIC"
321fi
322
323case "$platform" in
324generic)
325 need_sdl="yes"
326 ;;
327maemo)
328 CFLAGS="$CFLAGS -DMAEMO -DMAEMO_CHANGES"
329 ;;
330libretro)
331 CFLAGS="$CFLAGS -fPIC"
332 MAIN_LDFLAGS="$MAIN_LDFLAGS -shared -Wl,--no-undefined"
333 ;;
334esac
335
336# header/library presence tests
337check_zlib()
338{
339 cat > $TMPC <<EOF
340 #include <zlib.h>
341 int main(void) { uncompress(0, 0, 0, 0); }
342EOF
343 compile_binary
344}
345
346check_libpng()
347{
348 cat > $TMPC <<EOF
349 #include <png.h>
350 void main() { png_init_io(0, 0); }
351EOF
352 compile_binary
353}
354
355check_oss()
356{
357 cat > $TMPC <<EOF
358 #include <sys/soundcard.h>
359 #include <sys/ioctl.h>
360 void main() { int a=0; ioctl(0, SNDCTL_DSP_SETFMT, &a); }
361EOF
362 compile_binary
363}
364
365check_alsa()
366{
367 cat > $TMPC <<EOF
368 #include <alsa/asoundlib.h>
369 void main() { snd_pcm_open(0, 0, 0, 0); }
370EOF
371 compile_binary "$@"
372}
373
374check_pulseaudio()
375{
376 cat > $TMPC <<EOF
377 #include <pulse/pulseaudio.h>
378 void main() { pa_threaded_mainloop_new(); }
379EOF
380 compile_binary "$@"
381}
382
383check_sdl()
384{
385 cat > $TMPC <<EOF
386 #include <SDL.h>
387 void main() { SDL_OpenAudio(0, 0); }
388EOF
389 compile_binary "$@"
390}
391
392check_xlib_headers()
393{
394 cat > $TMPC <<EOF
395 #include <X11/Xlib.h>
396 void *f() { return XOpenDisplay(0); }
397EOF
398 compile_object "$@"
399}
400
401# see if we have c64_tools for TI C64x DSP
402check_c64_tools()
403{
404 cat > $TMPC <<EOF
405 #include <inc_libc64_mini.h>
406 int f() { return dsp_open(); }
407EOF
408 compile_object "$@"
409}
410
411MAIN_LDLIBS="$MAIN_LDLIBS -lz"
412check_zlib || fail "please install zlib (libz-dev)"
413
414MAIN_LDLIBS="-lpng $MAIN_LDLIBS"
415check_libpng || fail "please install libpng (libpng-dev)"
416
417# find what audio support we can compile
418if [ "x$sound_drivers" = "x" ]; then
419 if check_oss; then sound_drivers="$sound_drivers oss"; fi
420 if check_alsa -lasound; then
421 sound_drivers="$sound_drivers alsa"
422 MAIN_LDLIBS="-lasound $MAIN_LDLIBS"
423 fi
424 if check_pulseaudio -lpulse; then
425 sound_drivers="$sound_drivers pulseaudio"
426 MAIN_LDLIBS="-lpulse $MAIN_LDLIBS"
427 fi
428 if [ "$need_sdl" = "yes" ] || check_sdl `${SDL_CONFIG} --cflags --libs`; then
429 sound_drivers="$sound_drivers sdl"
430 need_sdl="yes"
431 fi
432else
433 if echo $sound_drivers | grep -q "\<oss\>"; then
434 check_oss || fail "oss support is missing"
435 fi
436 if echo $sound_drivers | grep -q "\<alsa\>"; then
437 MAIN_LDLIBS="-lasound $MAIN_LDLIBS"
438 check_alsa || fail "please install libasound2-dev"
439 fi
440 if echo $sound_drivers | grep -q "\<pulseaudio\>"; then
441 MAIN_LDLIBS="-lpulse $MAIN_LDLIBS"
442 check_pulseaudio || fail "pulseaudio support is missing"
443 fi
444fi
445
446if [ "$need_sdl" = "yes" ]; then
447 which ${SDL_CONFIG} > /dev/null || \
448 fail "sdl-config is missing; please install libsdl (libsdl1.2-dev)"
449 CFLAGS="$CFLAGS `${SDL_CONFIG} --cflags`"
450 MAIN_LDLIBS="`${SDL_CONFIG} --libs` $MAIN_LDLIBS"
451 check_sdl || fail "please install libsdl (libsdl1.2-dev)"
452fi
453
454# check for tslib (only headers needed)
455if [ "x$have_tslib" = "x" ]; then
456 cat > $TMPC <<EOF
457 #include <tslib.h>
458 void test(struct ts_sample sample) {}
459EOF
460 if compile_object; then
461 have_tslib="yes"
462 else
463 have_tslib="no"
464 fi
465fi
466
467# check for VideoCore stuff for Raspberry Pi
468if [ -d /opt/vc/include -a -d /opt/vc/lib -a "$VIDEOCORE" != "no" ]; then
469 CFLAGS_GLES="$CFLAGS_GLES -I/opt/vc/include -I/opt/vc/include/interface/vcos/pthreads -I/opt/vc/include/interface/vmcs_host/linux"
470 LDLIBS_GLES="$LDLIBS_GLES -L/opt/vc/lib"
471 if [ -f /opt/vc/lib/libbcm_host.so ]; then
472 LDLIBS_GLES="$LDLIBS_GLES -lbcm_host"
473 fi
474 need_xlib="yes"
475 VIDEOCORE="yes"
476fi
477
478# check for GLES headers
479cat > $TMPC <<EOF
480#include <GLES/gl.h>
481#include <EGL/egl.h>
482int main(void) {
483 return (int)eglGetDisplay( (EGLNativeDisplayType)0 );
484}
485EOF
486if [ "$VIDEOCORE" = "yes" ] && compile_binary $CFLAGS_GLES -lbrcmEGL -lbrcmGLESv2 $LDLIBS_GLES; then
487 have_gles="yes"
488 LDLIBS_GLES="-lbrcmEGL -lbrcmGLESv2 $LDLIBS_GLES"
489elif compile_binary $CFLAGS_GLES -lEGL -lGLES_CM $LDLIBS_GLES; then
490 have_gles="yes"
491 LDLIBS_GLES="-lEGL -lGLES_CM $LDLIBS_GLES"
492elif compile_binary $CFLAGS_GLES -lEGL -lGLESv1_CM $LDLIBS_GLES; then
493 have_gles="yes"
494 LDLIBS_GLES="-lEGL -lGLESv1_CM $LDLIBS_GLES"
495fi
496
497if check_c64_tools; then
498 have_c64x_dsp="yes"
499fi
500
501if [ "$have_gles" = "yes" ]; then
502 plugins="$plugins plugins/gpu-gles/gpu_gles.so"
503fi
504if [ "$have_arm_neon" = "yes" -a "$builtin_gpu" != "neon" ]; then
505 plugins="$plugins plugins/gpu_neon/gpu_neon.so"
506fi
507
508# check for xlib (only headers needed)
509if [ "x$need_xlib" = "xyes" ]; then
510 check_xlib_headers || fail "please install libx11-dev"
511fi
512
513sizeof_long=`check_define_val __SIZEOF_LONG__`
514if [ "x$sizeof_long" = "x4" ]; then
515 CFLAGS="$CFLAGS -D_FILE_OFFSET_BITS=64"
516fi
517
518cat > $TMPC <<EOF
519void test(void *f, void *d) { fread(d, 1, 1, f); }
520EOF
521if compile_object -Wno-unused-result; then
522 CFLAGS="$CFLAGS -Wno-unused-result"
523fi
524
525# short plugin list for display
526for p in $plugins; do
527 p1=`basename $p`
528 plugins_short="$p1 $plugins_short"
529done
530
531# set things that failed to autodetect to "no"
532test "x$have_armv6" != "x" || have_armv6="no"
533test "x$have_armv7" != "x" || have_armv7="no"
534test "x$have_arm_neon" != "x" || have_arm_neon="no"
535test "x$have_arm_neon_asm" != "x" || have_arm_neon_asm="no"
536test "x$have_gles" != "x" || have_gles="no"
537test "x$have_c64x_dsp" != "x" || have_c64x_dsp="no"
538
539echo "architecture $ARCH"
540echo "platform $platform"
541echo "built-in GPU $builtin_gpu"
542echo "sound drivers $sound_drivers"
543echo "plugins $plugins_short"
544echo "C compiler $CC"
545echo "C compiler flags $CFLAGS"
546echo "libraries $MAIN_LDLIBS"
547echo "linker flags $LDFLAGS$MAIN_LDFLAGS"
548echo "enable dynarec $enable_dynarec"
549if [ "$ARCH" = "arm" -o "$ARCH" = "aarch64" ]; then
550 echo "enable ARM NEON $have_arm_neon"
551fi
552if [ "$ARCH" = "arm" ]; then
553 echo "ARMv7 optimizations $have_armv7"
554 echo "TI C64x DSP support $have_c64x_dsp"
555fi
556echo "tslib support $have_tslib"
557if [ "$platform" = "generic" ]; then
558 echo "OpenGL ES output $have_gles"
559fi
560
561echo "# Automatically generated by configure" > $config_mak
562printf "# Configured with:" >> $config_mak
563printf " '%s'" "$0" "$@" >> $config_mak
564echo >> $config_mak
565
566echo "CC = $CC" >> $config_mak
567echo "CXX = $CXX" >> $config_mak
568echo "AS = $AS" >> $config_mak
569echo "CFLAGS += $CFLAGS" >> $config_mak
570echo "ASFLAGS += $ASFLAGS" >> $config_mak
571echo "LDFLAGS += $LDFLAGS" >> $config_mak
572echo "MAIN_LDFLAGS += $MAIN_LDFLAGS" >> $config_mak
573echo "MAIN_LDLIBS += $MAIN_LDLIBS" >> $config_mak
574echo "PLUGIN_CFLAGS += $PLUGIN_CFLAGS" >> $config_mak
575echo >> $config_mak
576
577if [ "$platform" = "libretro" ]; then
578 echo "TARGET = libretro.so" >> $config_mak
579fi
580echo "ARCH = $ARCH" >> $config_mak
581echo "PLATFORM = $platform" >> $config_mak
582echo "BUILTIN_GPU = $builtin_gpu" >> $config_mak
583echo "SOUND_DRIVERS = $sound_drivers" >> $config_mak
584echo "PLUGINS = $plugins" >> $config_mak
585if [ "$have_arm_neon" = "yes" ]; then
586 echo "HAVE_NEON = 1" >> $config_mak
587fi
588if [ "$have_arm_neon_asm" = "yes" ]; then
589 echo "HAVE_NEON_ASM = 1" >> $config_mak
590fi
591if [ "$have_tslib" = "yes" ]; then
592 echo "HAVE_TSLIB = 1" >> $config_mak
593fi
594if [ "$have_gles" = "yes" ]; then
595 echo "HAVE_GLES = 1" >> $config_mak
596 echo "CFLAGS_GLES = $CFLAGS_GLES" >> $config_mak
597 echo "LDLIBS_GLES = $LDLIBS_GLES" >> $config_mak
598fi
599if [ "$enable_dynarec" = "yes" ]; then
600 echo "USE_DYNAREC = 1" >> $config_mak
601fi
602if [ "$drc_cache_base" = "yes" ]; then
603 echo "BASE_ADDR_DYNAMIC = 1" >> $config_mak
604fi
605if [ "$have_c64x_dsp" = "yes" ]; then
606 echo "HAVE_C64_TOOLS = 1" >> $config_mak
607fi
608
609# use pandora's skin (for now)
610test -e skin || ln -s frontend/pandora/skin skin
611
612# vim:shiftwidth=2:expandtab